## tdb 1.4.9

=== debian/changelog ===
tdb (1.4.9-2~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports (no changes).

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 06 Oct 2023 18:24:13 +0300

tdb (1.4.9-2) unstable; urgency=medium

  [ Jelmer Vernooĳ ]
  * debian/upstream/metadata: Add Repository, Repository-Browse

  [ Michael Tokarev ]
  * d/rules: wrap _PYTHON_SYSCONFIGDATA_NAME setting to cross-compile case
    On e.g. buster, _PYTHON_SYSCONFIGDATA_NAME is different, so this assignment
    does not work right.  In order for it to work on buster, add condition on
    host vs build gnu type. This breaks compilation with foreign python binary.

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 04 Aug 2023 14:23:27 +0300

tdb (1.4.9-1) unstable; urgency=medium

  * new upstream release

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 30 Jul 2023 23:12:17 +0300
