=== debian/changelog ===
tdb (1.4.10-1build1) noble; urgency=high

  * No change rebuild for 64-bit time_t and frame pointers.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 18:20:50 +0200

tdb (1.4.10-1) unstable; urgency=medium

  * new upstream (minor) release

 -- Michael Tokarev <mjt@tls.msk.ru>  Mon, 29 Jan 2024 20:10:24 +0300
