=== debian/control ===
Source: tdb
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Samba Maintainers <pkg-samba-maint@lists.alioth.debian.org>
Uploaders: Jelmer Vernooĳ <jelmer@debian.org>,
           Mathieu Parent <sathieu@debian.org>,
           Michael Tokarev <mjt@tls.msk.ru>
Build-Depends: debhelper-compat (= 13),
               dh-sequence-python3,
               docbook-xml, docbook-xsl, xsltproc,
# use {python3,libpython3}-ALL-dev to build for all python3 versions (+#904999):
               python3-dev:any | python3-dev, libpython3-dev,
# host python is needed for selftests
               python3 <!nocheck>,
Rules-Requires-Root: no
Homepage: https://tdb.samba.org/
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/samba-team/tdb
Vcs-Git: https://salsa.debian.org/samba-team/tdb.git

Package: libtdb1
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Trivial Database - shared library
 This is a simple database API. It is modelled after the structure
 of GDBM. TDB features, unlike GDBM, multiple writers support with
 appropriate locking and transactions.
 .
 This package contains the shared library file.

Package: tdb-tools
Section: utils
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Trivial Database - bundled binaries
 This is a simple database API. It is modelled after the structure
 of GDBM. TDB features, unlike GDBM, multiple writers support with
 appropriate locking and transactions.
 .
 This package contains bundled test and utility binaries

Package: libtdb-dev
Multi-Arch: same
Provides: tdb-dev
Section: libdevel
Architecture: any
Depends: libc6-dev, libtdb1 (= ${binary:Version}), ${misc:Depends}
Description: Trivial Database - development files
 This is a simple database API. It is modelled after the structure
 of GDBM. TDB features, unlike GDBM, multiple writers support with
 appropriate locking and transactions.
 .
 This package contains the development files.

Package: python3-tdb
Section: python
Architecture: any
Depends: libtdb1 (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: Python3 bindings for TDB
 This is a simple database API. It is modelled after the structure
 of GDBM. TDB features, unlike GDBM, multiple writers support with
 appropriate locking and transactions.
 .
 This package contains the Python3 bindings.
