=== debian/tests/control ===
Tests: python3-testsuite
Depends: python3-tdb, python3
Restrictions: allow-stderr
