## tdb 1.4.12

=== debian/changelog ===
tdb (1.4.12-1) unstable; urgency=medium

  * New upstream version 1.4.12
  * d/libtdb1.symbols: add new version
    (and remove mistaken version form from previous upload)
  * d/control: bump Standards-Version to 4.7.0
    (no changes needed)

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 14 Aug 2024 12:40:04 +0300

tdb (1.4.11-2) unstable; urgency=medium

  * d/libtdb1.symbols: add the forgotten new version marker

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 30 Jul 2024 11:55:59 +0300

tdb (1.4.11-1) unstable; urgency=medium

  * New upstream version 1.4.11
  * d/libtdb1.symbols: use #PACKAGE# placeholder

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 30 Jul 2024 11:49:50 +0300
