=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: tdb
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Samba Maintainers <pkg-samba-maint@lists.alioth.debian.org>
+Maintainer: Debian Samba Maintainers <pkg-samba-maint@lists.alioth.debian.org>
 Uploaders: Jelmer Vernooĳ <jelmer@debian.org>,
            Mathieu Parent <sathieu@debian.org>,
            Michael Tokarev <mjt@tls.msk.ru>
@@ -15,7 +14,7 @@
                python3 <!nocheck>,
 Rules-Requires-Root: no
 Homepage: https://tdb.samba.org/
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/samba-team/tdb
 Vcs-Git: https://salsa.debian.org/samba-team/tdb.git
