## tdb 2.7.7-1uk1

=== debian/changelog ===
tdb (2.7.7-1uk1) unstable; urgency=low

  * amd64 rebuild

 -- Albrecht Gebhardt <albrecht.gebhardt@uni-klu.ac.at>  Tue, 22 May 2012 06:22:11 +0000

tdb (2.7.7-1uk) unstable; urgency=low

  * initial package

 -- Albrecht Gebhardt <albrecht.gebhardt@uni-klu.ac.at>  Sun, 12 Jul 2009 21:21:39 +0000
