=== debian/control ===
Source: tdb
Section: math
Priority: extra
Maintainer: Albrecht Gebhardt <agebhard@pc30-math>

Package: tdb
Architecture: amd64
Depends: ${shlibs:Depends}
Description: Trust Desk Basic
 Trust Desk Basic client for Austrian Buergercard
